indir='/data/Satellite/OMI/NO2/HDF/'
openr,1,'omi_l2.fil'
nfiles=0
readf,1,nfiles
old_day='20080331'
for nf=0,nfiles-1 do begin
infl=''
readf,1,infl
yr=strmid(infl,18,4)
mn=strmid(infl,23,2)
dy=strmid(infl,25,2)
new_day=yr+mn+dy
infile=indir+infl

result=H5F_IS_HDF5(infile)

if result eq 1 then begin 

; Open HDF5-based file
file_id=H5F_OPEN(infile)

;result=H5_BROWSER(infile)
;stop

;result=H5_PARSE(infile)
;help,result,/structure
;stop

;------------------------------------------------;
; Get Group Info
;------------------------------------------------;
param0='/HDFEOS'
g0_id = H5G_OPEN(file_id,param0)
gnum=H5G_GET_NMEMBERS(g0_id,param0)

for inum=0L,gnum-1L do begin
 group_name=H5G_GET_MEMBER_NAME(g0_id,param0,inum)
 ; Two groups 'ADDITIONAL' and 'GRIDS'
print,group_name
endfor
H5G_CLOSE,g0_id

;------------------------------------------------;
; Get Attributes
;------------------------------------------------;
param1='/HDFEOS/ADDITIONAL/FILE_ATTRIBUTES/'
g1_id = H5G_OPEN(file_id,param1)

attr_num=H5A_GET_NUM_ATTRS(g1_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(g1_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
print,attr_name
endfor
H5G_CLOSE,g1_id
;------------------------------------------------;

;------------------------------------------------;
; Get Grid info
;------------------------------------------------;
; Global data param2='/HDFEOS/GRIDS' 
param2='/HDFEOS/SWATHS'
g2_id = H5G_OPEN(file_id,param2)
gnum=H5G_GET_NMEMBERS(g2_id,param2)
for inum=0L,gnum-1L do begin
 gname=H5G_GET_MEMBER_NAME(g2_id,param2,inum)
print,gname
endfor
H5G_CLOSE,g2_id
;stop
param3=param2+'/ColumnAmountNO2'
g3_id = H5G_OPEN(file_id,param3)
gnum=H5G_GET_NMEMBERS(g3_id,param3)
for inum=0L,gnum-1L do begin
 gname=H5G_GET_MEMBER_NAME(g3_id,param3,inum)
 ;print,gname
endfor
H5G_CLOSE,g3_id

param4=param3+'/Data Fields'
g4_id = H5G_OPEN(file_id,param4)
dnum=H5G_GET_NMEMBERS(g4_id,param4)
;comment=H5G_GET_COMMENT(g4_id,param4)

dname=strarr(dnum)
for inum=0L,dnum-1L do begin
 dname(inum)=H5G_GET_MEMBER_NAME(g4_id,param4,inum)
 print,inum,':   ',dname(inum)
endfor

;stop
;          22:   CloudFraction
;          26:   CloudRadianceFraction
;          27:   ColumnAmountNO2
;          35:   ColumnAmountNO2Trop
;          39:   FitQualityFlags
;          41:   MeasurementQualityFlags

index=35
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
no2=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(no2),', min=',min(no2)
help,no2
stop
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'	',attr_name,': ',attr 
endfor
print,''

H5D_CLOSE,d_id

index=26
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
ref=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(ref),', min=',min(ref)

print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''
;stop
H5D_CLOSE,d_id
index=39
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
qual=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(qual),', min=',min(qual)

print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
print,''

param6=param3+'/Geolocation Fields'
g6_id = H5G_OPEN(file_id,param6)
dnum=H5G_GET_NMEMBERS(g6_id,param6)
;comment=H5G_GET_COMMENT(g6_id,param6)

dname=strarr(dnum)
for inum=0L,dnum-1L do begin
 dname(inum)=H5G_GET_MEMBER_NAME(g6_id,param6,inum)
 print,inum,':   ',dname(inum)
endfor
print,''
print,''


index=2
print,';-----------------------------------------------------;'
print,'             Extracting ', dname(index)
print,';-----------------------------------------------------;'

param_lon=param6+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g6_id,param_lon)
lon=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(lon),', min=',min(lon)

print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'	',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id

print,''

index=1
print,';-----------------------------------------------------;'
print,'    Extracting ', dname(index)
print,';-----------------------------------------------------;'

param_lat=param6+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g6_id,param_lat)
lat=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(lat),', min=',min(lat)

print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'	',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
;stop


index=8
print,';-----------------------------------------------------;'
print,'    Extracting ', dname(index)
print,';-----------------------------------------------------;'

param_lat=param6+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g6_id,param_lat)
time=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(time),', min=',min(time)

print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id

index=4
print,';-----------------------------------------------------;'
print,'    Extracting ', dname(index)
print,';-----------------------------------------------------;'

param_lat=param6+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g6_id,param_lat)
secday=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(secday),', min=',min(secday)

print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id

print,''
print,''


H5G_CLOSE, g4_id
;stop
endif; HDF5 check
if new_day ne old_day then begin
ofile='OMI'+yr+mn+dy+'.int.no2'
odir='/data/Satellite/OMI/NO2/Binary/'
close,2
openw,2,odir+ofile
old_day=new_day
endif
result=size(no2)
nc=result(1)
nr=result(2)
help,no2,secday,lon,lat,ref,qual
;stop
for j=0,nr-1 do begin
t=long(secday(j))
for i=0,nc-1 do begin
x=lon(i,j)
y=lat(i,j)
o=no2(i,j)
r=ref(i,j)
q=qual(i,j)
if o gt 0. then printf,2,t,y,x,o,r,q
endfor
endfor
endfor
close,2
end

